/* REXX installation script for Unicode Conversion library fix.
 * Copyright (C) 2009 Dmitry A.Steklenev
 */

globals = "sys."

if RxFuncQuery('SysLoadFuncs') then do
   call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
   call SysLoadFuncs
end

parse upper value VALUE( "PATH",, "OS2ENVIRONMENT" ) with "\OS2\SYSTEM" -2,
      sys.boot_disk +2
      
sys.dlls = sys.boot_disk"\OS2\DLL\"
      
parse upper arg make

if abbrev( "/INSTALL", make, 2 ) then
  return install()
else if abbrev( "/UNINSTALL", make, 2 ) then
  return uninstall()
else do
  say "Use UCONVFIX.CMD /INSTALL   for applying fix,"
  say " or UCONVFIX.CMD /UNINSTALL for removing fix."
end
return 1
         
install: procedure expose (globals)

  if stream( sys.dlls"UCONV.ECS", "C", "QUERY EXIST" ) == "" then do
     if \CopyFile( sys.dlls"UCONV.DLL", sys.dlls"UCONV.ECS" ) then exit 2
  end
  
  if \CopyFile( "UCV32.DLL", sys.dlls"UCV32.DLL" ) then exit 2
  if \CopyFile( "UCONV.DLL", sys.dlls"UCONV.DLL" ) then exit 2

  say ""
  say "The fix is applied successfully."
  say "Please restart your system for changes to take effect!"
return 0

uninstall: procedure expose (globals)
  if stream( sys.dlls"UCONV.ECS", "C", "QUERY EXIST" ) \= "" then do
    if CopyFile( sys.dlls"UCONV.ECS", sys.dlls"UCONV.DLL" ) then do
       "@del "sys.dlls"UCONV.ECS"
    end
  end

  say ""
  say "The fix is removed successfully."
  say "Please restart your system for changes to take effect!"
return 0

CopyFile: procedure expose (globals)

  parse arg from, to
  '@dllreplace "'from'" "'to'"'

  select
    when rc == 0 then
       say "File copied successfully: "  || from
    when rc == 1 then
       say "File copied successfully: "  || from
    otherwise
       say "Error during file copying: " || from || ", rc="rc
  end

return rc == 0 | rc == 1
