#include <stdio.h>
#include <string.h>
#include <uconv.h>
#include <process.h>

#define  INCL_DOS
#include <os2.h>

static failed = 0;

static void
test_thread( void* scrap )
{
  UconvObject uconv1252;
  int tries;
  int rc;

  for ( tries=0; tries < 100000; tries++ ) {
    rc = UniCreateUconvObject( (UniChar *)L"IBM-1252", &uconv1252 );

    if ( rc ) {
      printf( "UniCreateUconvObject(1252)=%08X\n", rc );
      failed++;
      break;
    }

    rc = UniFreeUconvObject( uconv1252 );

    if ( rc ) {
      printf( "UniFreeUconvObject(1252)=%08X\n", rc );
      failed++;
      break;
    }
  }

  printf( "tries=%d\n", tries );
}

int main()
{
  TID tid1, tid2, tid3;

  printf( "The Unicode Conversion test is started. Please, wait a few minutes...\n" );

  tid1 = _beginthread( test_thread, NULL, 65535, NULL );
  tid2 = _beginthread( test_thread, NULL, 65535, NULL );
  tid3 = _beginthread( test_thread, NULL, 65535, NULL );

  DosWaitThread( &tid1, DCWW_WAIT );
  DosWaitThread( &tid2, DCWW_WAIT );
  DosWaitThread( &tid3, DCWW_WAIT );

  if( failed ) {
    printf( "The Unicode Conversion test is failed.\nYou needed to fix the UCONV.DLL.\n" );
  } else {
    printf( "The Unicode Conversion test is passed.\n" );
  }

  return 0;
}
